%P. Kano
%August 24, 2005

function [TruncationError,RoundoffError,EstimatedTotalError] =...
WeeksErrorEstimate(Unitmatrix,Trianmatrix,Bvector,NNodes,NLaguerreCoef,MInversions,SigmaWeeks,BetaWeeks,LagSwitch)

%Compute the Laguerre Coefficients
if(LagSwitch==0)
[ErLaguerreCoef] = WeeksMidPntLagCoef(Unitmatrix,Trianmatrix,Bvector,NNodes,2*NLaguerreCoef,2*MInversions,SigmaWeeks,BetaWeeks);
elseif(LagSwitch==1)
[FFTSamples] = WeeksFFTSample(Unitmatrix,Trianmatrix,Bvector,NNodes,2*NLaguerreCoef,SigmaWeeks,BetaWeeks);
[ErLaguerreCoef] = WeeksFFTLagCoef(FFTSamples,NNodes,2*NLaguerreCoef);
clear FFTSamples;
else
[ErLaguerreCoef] =...
WeeksMidPntLagCoef(Unitmatrix,Trianmatrix,Bvector,NNodes,2*NLaguerreCoef,2*MInversions,SigmaWeeks,BetaWeeks);
end

ErLaguerreCoef = abs(ErLaguerreCoef).^2;

TruncationError = sqrt(sum(sum(ErLaguerreCoef(:,NLaguerreCoef:1:2*NLaguerreCoef))));
RoundoffError = (2^(-52))*sqrt(sum(sum(ErLaguerreCoef(:,1:1:NLaguerreCoef))));

EstimatedTotalError = exp(SigmaWeeks)*(TruncationError+RoundoffError);


