%P. Kano
%November 1, 2005

function [SigmaWeeks,BetaWeeks,Unitmatrix,Trianmatrix,EstimatedTotalError] =...
WeeksWeidemanParam(Amatrix,Bvector,NLaguerreCoef,MInversions,LagSwitch,SigmaDistance,DeltaSigma,BetaMin,BetaMax,DeltaBeta)

NNodes = size(Bvector,1); 
if(NNodes~=size(Amatrix,2)) error('Check sizes of matrix and vector \n'); end

%Schur Decomposition
[Unitmatrix,Trianmatrix] = schur(full(Amatrix),'complex');
DiagVec = diag(Trianmatrix);

%Parameter Ranges
[SigmaMin,MaxRealPos] = max(real(DiagVec));

SigmaMax = SigmaMin + SigmaDistance;

if(SigmaMax<=SigmaMin) error('Maximum Sigma is less than the Minimum Sigma'); end

optnew = optimset('TolX',DeltaSigma);
[SigmaWeeks,EstimatedTotalError,ExitFlag,ExitOutput] =...
fminbnd('WeeksWeidemanError',SigmaMin,SigmaMax,optnew,Unitmatrix,Trianmatrix,Bvector,NNodes,NLaguerreCoef,MInversions,LagSwitch,SigmaMax,DeltaSigma,BetaMin,BetaMax,DeltaBeta);

optnew = optimset('TolX',DeltaBeta);
[BetaWeeks,Rinverse,ExitFlag,ExitOutput] =...
fminbnd('WeeksMinBeta',BetaMin,BetaMax,optnew,SigmaWeeks,Trianmatrix);
